//****************************************************************
//
//    Class funct_def
//
//    Description:
//      funct_def is a class for storing information of a function
//	definition.
//
//      If you discover any bugs, it would be very helpful if
//      you sent me e-mail.  Thank you.
//
//      Author:                Peter Braaten
//      e-mail:                braa0007@mermaid.micro.umn.edu
//      Date last modified:    July 18, 1995
//
//****************************************************************

/*===========================================================================
				PRIVATE :
				--------

    char * ret;     // name of the value returned by the function
    char * args;    // comma-list of the arguments
    char * body;    // body of the function

	       		       FUNCTIONS :
			       ----------
constructors
destructor

get_ret : 	returns the name of the variable returned by the function
get_args : 	returns the list of the arguments 
get_body : 	returns the body of the function
get_argc : 	returns the number of the arguments of the function
get_arg(i) : 	returns a string pointer to the ith argument of the function

===========================================================================*/



#ifndef FUNCT_DEF_H
#define FUNCT_DEF_H

#include <iostream.h> 
#include <assert.h>
#include <string.h>

class funct_def {

  public:
    // Constructors
    funct_def ();
    funct_def (char *, char *, char *);
    funct_def (const funct_def &);

    void free();

    // Destructor
    ~funct_def();

    // Selectors
    char *  get_ret() const;
    char *  get_args() const;
    char *  get_body() const;
    int get_argc() const;
    char * get_arg(int) const;

    int size();

  private:
    // Data
    char * ret;     // name of the value returned by the function
    char * args;    // comma-list of the arguments
    char * body;    // body of the function

}; // end class dense


extern int is_letter (char);

#endif
