//****************************************************************
//
//      Class history
//
//      List is a class for implementing a history list.
//
//      If you discover any bugs, it would be very helpful if
//      you sent me e-mail.  Thank you.
//
//      Author:                Peter Braaten
//      e-mail:                braa0007@mermaid.micro.umn.edu
//      Date last modified:    July 12, 1994
//
//****************************************************************

/*==========================================================================
			PRIVATE :
			--------

    int size;               // Size of the history list
    int current;            // Number of the most recent item.
    string * hist;          // Pointer to the list itself.

Each entry of the list contains :
	- the number of the line
	- the line

			FUNCTIONS :
			----------
constructors
destructor

get_item(i): 	gets the ith iten of the list : the number and the line
put_item(it) : 	puts the item it at the end of the history list
out : 		outputs the history list

==========================================================================*/


#ifndef HISTORY_H
#define HISTORY_H

#include "string.h"

class history {

  public:
    // Constructors
    history (int);

    // Selectors
    string get_item (int);

    // Functions
    void put_item (string &);
    void out ();

  private:
    // Data
    int size;               // Size of the history list
    int current;            // Number of the most recent item.
    string * hist;          // Pointer to the list itself.

}; // end class history


void output (history &);

#endif
