//****************************************************************
//
//      Class link
// 
//      Link is a class that will hold one element and one 
//      pointer of a linked list.  For the most part, the
//      the only direct user of this class should be the
//      class list. 
//
//      If you discover any bugs, it would be very helpful if
//      you sent me e-mail.  Thank you.
//
//      Author:                Peter Braaten
//      e-mail:                braa0007@mermaid.micro.umn.edu
//      Date last modified:    July 10, 1995
//
//****************************************************************

/*=========================================================================
			PRIVATE :
			--------
    entry thing;	
    link *pointer;	// pointer to the linked list

			FUNCTIONS :
			---------
constructors
destructor

get_item : 		returns the item field 
get_pointer : 		returns the pointer field (ptr to the linked list)
insert(en) : 		inserts a new link at the beginning 
set_pointer(p) : 	sets the pointer field to p

=========================================================================*/

#ifndef LINK_H
#define LINK_H
#define link linked

#include "entry.h"

class link {

  public:

    // constructors
    link (entry, link *);
    link (entry);
    link ();
    link (const link &);

    // selectors
    entry get_item () const;
    link* get_ptr () const;
 
    // mutators
    link* insert (entry);
    void set_pointer (link *);

  private:

    entry thing;	
    link *pointer;	// pointer to the next entry
}; // end class link

#endif
